<template>
  <div class="user-joined-add-on">
    <i class="bi bi-person-badge me-2"></i>
    <span data-bs-toggle="tooltip" :title="joinedTooltip">Joined {{ joinedText }}</span>
  </div>
</template>

<script>
import { ref, onUnmounted } from 'vue'
import { useStore } from 'vuex'
import { useMoment } from '../../core'

export default {
  name: 'UserJoinedAddOn',
  props: {
    user: { type: Object, required: true },
  },
  setup(props) {
    const store = useStore()
    const moment = useMoment()

    const joinedText = ref('')
    const joinedTooltip = ref('')

    const updateRelativeMomentText = () => {
      const joinedRelative = moment(props.user.created).fromNow()
      const joinedAbsolute = moment(props.user.created).format('llll')

      const relativeDatetimes = store.state.core.persisted.relativeDatetimes
      joinedText.value = relativeDatetimes ? joinedRelative : joinedAbsolute
      joinedTooltip.value = relativeDatetimes ? joinedAbsolute : joinedRelative
    }

    onUnmounted(() => {
      clearInterval(interval)
    })

    let interval = setInterval(() => {
      updateRelativeMomentText()
    }, 1000)

    updateRelativeMomentText()

    return {
      joinedText,
      joinedTooltip,
    }
  },
}
</script>
